## xtensor-blas 0.18.0

=== CMakeLists.txt ===
############################################################################
# Copyright (c) Johan Mabille, Sylvain Corlay and Wolf Vollprecht          #
# Copyright (c) QuantStack                                                 #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)
project(xtensor-blas)

set(INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(XTENSOR_BLAS_INCLUDE_DIR ${INCLUDE_DIR})

# Configuration
# =============

# TODO: use the library directory of the found BLAS implementation instead of
# CMAKE_INSTALL_LIBDIR
set(XTENSOR_BLAS_CLING_LIBRARY_DIR_64 "\"${CMAKE_INSTALL_PREFIX}/lib64\"")
set(XTENSOR_BLAS_CLING_LIBRARY_DIR_32 "\"${CMAKE_INSTALL_PREFIX}/lib32\"")
set(XTENSOR_BLAS_CLING_LIBRARY_DIR "\"${CMAKE_INSTALL_PREFIX}/lib\"")

configure_file (
    "${INCLUDE_DIR}/xtensor-blas/xblas_config_cling.hpp.in"
    "${INCLUDE_DIR}/xtensor-blas/xblas_config_cling.hpp"
)

# Versionning
# ===========

file(STRINGS "${INCLUDE_DIR}/xtensor-blas/xblas_config.hpp" xtensor_blas_version_defines
     REGEX "#define XTENSOR_BLAS_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xtensor_blas_version_defines})
    if(ver MATCHES "#define XTENSOR_BLAS_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XTENSOR_BLAS_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(${PROJECT_NAME}_VERSION
    ${XTENSOR_BLAS_VERSION_MAJOR}.${XTENSOR_BLAS_VERSION_MINOR}.${XTENSOR_BLAS_VERSION_PATCH})
message(STATUS "xtensor-blas v${${PROJECT_NAME}_VERSION}")

# Dependencies
# ============

find_package(xtensor 0.21 REQUIRED)
message(STATUS "Found xtensor: ${xtensor_INCLUDE_DIRS}/xtensor")

# Build
# =====

set(XTENSOR_BLAS_HEADERS
    ${INCLUDE_DIR}/xtensor-blas/xblas.hpp
    ${INCLUDE_DIR}/xtensor-blas/xblas_utils.hpp
    ${INCLUDE_DIR}/xtensor-blas/xblas_config.hpp
    ${INCLUDE_DIR}/xtensor-blas/xblas_config_cling.hpp
    ${INCLUDE_DIR}/xtensor-blas/xlapack.hpp
    ${INCLUDE_DIR}/xtensor-blas/xlinalg.hpp
)

add_library(xtensor-blas INTERFACE)

target_include_directories(xtensor-blas
  INTERFACE
    $<BUILD_INTERFACE:${XTENSOR_BLAS_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include>)

OPTION(CXXBLAS_DEBUG "print cxxblas debug information" OFF)
OPTION(XTENSOR_USE_FLENS_BLAS "use FLENS generic implementation instead of cblas" OFF)
# Decide whether to use OpenBLAS or not.
# The user might have the folder containing OpenBLASConfig.cmake file
# in the paths inspected by CMake already and just setting this to ON
# would be enough to detect OpenBLAS.
# If that is not the case, one can pass OpenBLAS_DIR without the boolean
# toggle.
OPTION(USE_OPENBLAS "use OpenBLAS (requires suitable OpenBLASConfig.cmake)" OFF)
if(OpenBLAS_DIR)
  set(USE_OPENBLAS ON)
endif()

if(XTENSOR_USE_FLENS_BLAS)
  add_definitions(-DXTENSOR_USE_FLENS_BLAS=1)
endif()

if (CXXBLAS_DEBUG)
  add_definitions(-DCXXBLAS_DEBUG=1)
endif()

OPTION(BUILD_TESTS "xtensor-blas test suite" OFF)
OPTION(BUILD_BENCHMARK "xtensor-blas test suite" OFF)

OPTION(DOWNLOAD_GTEST "download gtest and build from source" OFF)
OPTION(DOWNLOAD_GBENCHMARK "download google benchmark and build from source" OFF)

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    set(BUILD_TESTS ON)
endif()

if(BUILD_TESTS)
    enable_testing()
    include_directories(${XTENSOR_BLAS_INCLUDE_DIR})
    include_directories(${xtensor_INCLUDE_DIRS})
    add_subdirectory(test)
endif()

if(BUILD_BENCHMARKS)
    include_directories(${XTENSOR_BLAS_INCLUDE_DIR})
    include_directories(${xtensor_INCLUDE_DIRS})
    add_subdirectory(benchmark)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(TARGETS xtensor-blas
        EXPORT ${PROJECT_NAME}-targets)

# Makes the project importable from the build directory
export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

install(FILES ${XTENSOR_BLAS_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtensor-blas)

install(DIRECTORY ${INCLUDE_DIR}/xflens
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        PATTERN *.tgz EXCLUDE
        PATTERN Makefile EXCLUDE
        PATTERN dummy.in.cc EXCLUDE
        PATTERN filter.pm EXCLUDE
        PATTERN CMakeLists.txt EXCLUDE)

set(XTENSOR_BLAS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE
    STRING "install path for xtensor-blasConfig.cmake")

configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${XTENSOR_BLAS_CMAKECONFIG_INSTALL_DIR})

# xtensor is header-only and does not depend on the architecture.
# Remove CMAKE_SIZEOF_VOID_P from xblasConfigVersion.cmake so that an xblasConfig.cmake
# generated for a 64 bit target can be used for 32 bit targets and vice versa.
set(_XTENSOR_BLAS_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
unset(CMAKE_SIZEOF_VOID_P)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                 VERSION ${${PROJECT_NAME}_VERSION}
                                 COMPATIBILITY AnyNewerVersion)
set(CMAKE_SIZEOF_VOID_P ${_XTENSOR_CMAKE_SIZEOF_VOID_P})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${XTENSOR_BLAS_CMAKECONFIG_INSTALL_DIR})

install(EXPORT ${PROJECT_NAME}-targets
        FILE ${PROJECT_NAME}Targets.cmake
        DESTINATION ${XTENSOR_BLAS_CMAKECONFIG_INSTALL_DIR})

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) Johan Mabille, Sylvain Corlay and Wolf Vollprecht          #
# Copyright (c) QuantStack                                                 #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xtensor-blas-test)

    enable_testing()

    find_package(xtensor REQUIRED CONFIG)
    set(XTENSOR_INCLUDE_DIR ${xtensor_INCLUDE_DIRS})
    find_package(xtensor-blas REQUIRED CONFIG)
    set(XTENSOR_BLAS_INCLUDE_DIR ${xblas_INCLUDE_DIRS})
endif ()

if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Setting tests build type to Release")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
else()
    message(STATUS "Tests build type is ${CMAKE_BUILD_TYPE}")
endif()

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

include(set_compiler_flag.cmake)

if(CPP17)
  # User requested C++17, but compiler might not oblige.
  set_compiler_flag(
    _cxx_std_flag CXX
    "-std=c++17"  # this should work with GNU, Intel, PGI
    "/std:c++17"  # this should work with MSVC
  )
  if(_cxx_std_flag)
    message(STATUS "Building with C++17")
  endif()
else()
  set_compiler_flag(
    _cxx_std_flag CXX REQUIRED
    "-std=c++14"  # this should work with GNU, Intel, PGI
    "/std:c++14"  # this should work with MSVC
  )
  message(STATUS "Building with C++14")
endif()

if(NOT _cxx_std_flag)
  message(FATAL_ERROR "xtensor-blas needs a C++14-compliant compiler.")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR (CMAKE_CXX_COMPILER_ID MATCHES "Intel" AND NOT WIN32))
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_cxx_std_flag} -march=native -Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast -Wunused-variable")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_cxx_std_flag} /EHsc /MP /bigobj /wd4800")
  set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_cxx_std_flag} -march=native -Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast -Wunused-variable")
  else() # We are using clang-cl
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_cxx_std_flag} /EHsc /MP /bigobj -Wno-unused-command-line-argument")
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING)
  endif()
else()
  message(FATAL_ERROR "Unsupported compiler: ${CMAKE_CXX_COMPILER_ID}")
endif()

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    if(DOWNLOAD_GTEST)
        # Download and unpack googletest at configure time
        configure_file(downloadGTest.cmake.in googletest-download/CMakeLists.txt)
    else()
        # Copy local source of googletest at configure time
        configure_file(copyGTest.cmake.in googletest-download/CMakeLists.txt)
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL)

    set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
    add_library(GTest::GTest INTERFACE IMPORTED)
    target_link_libraries(GTest::GTest INTERFACE gtest)
    add_library(GTest::Main INTERFACE IMPORTED)
    target_link_libraries(GTest::Main INTERFACE gtest_main)
else()
    find_package(GTest REQUIRED)
endif()

find_package(Threads)

include_directories(${GTEST_INCLUDE_DIRS} SYSTEM)
include_directories(${XTENSOR_INCLUDE_DIR})
include_directories(${XBLAS_INCLUDE_DIR})

if(USE_OPENBLAS)
    find_package(OpenBLAS REQUIRED)
    set(BLAS_LIBRARIES ${CMAKE_INSTALL_PREFIX}${OpenBLAS_LIBRARIES})
else()
    find_package(BLAS REQUIRED)
    find_package(LAPACK REQUIRED)
endif()

message(STATUS "BLAS VENDOR:    " ${BLA_VENDOR})
message(STATUS "BLAS LIBRARIES: " ${BLAS_LIBRARIES})

set(XTENSOR_BLAS_TESTS
    main.cpp
    test_blas.cpp
    test_lapack.cpp
    test_linalg.cpp
    test_lstsq.cpp
    test_qr.cpp
    test_dot.cpp
    test_tensordot.cpp
    test_lstsq.cpp
    test_dot.cpp
    test_dot_extended.cpp
    test_qr.cpp
)

add_executable(test_xtensor_blas ${XTENSOR_BLAS_TESTS} ${XTENSOR_BLAS_HEADERS} ${XTENSOR_HEADERS})
if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    add_dependencies(test_xtensor_blas gtest_main)
endif()

target_link_libraries(test_xtensor_blas ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES} GTest::GTest GTest::Main ${CMAKE_THREAD_LIBS_INIT})

add_custom_target(xtest COMMAND test_xtensor_blas DEPENDS test_xtensor_blas)
add_test(NAME xtest COMMAND test_xtensor_blas)

=== debian/changelog ===
xtensor-blas (0.18.0-2) unstable; urgency=medium

  * Rename header library as libxtensor-blas-dev
    - Depends: libxtensor-dev

 -- Drew Parsons <dparsons@debian.org>  Mon, 26 Apr 2021 10:23:51 +0200

xtensor-blas (0.18.0-1) unstable; urgency=medium

  * Initial release (Closes: #985020)
    - xtensor-blas builds against xtensor 0.22.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 15 Mar 2021 00:37:24 +0100

=== debian/control ===
Source: xtensor-blas
Priority: optional
Maintainer: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.1),
 libxtensor-dev (>= 0.22.0~), libxtensor-dev (<< 0.23.0),
 libblas-dev | libblis-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 googletest <!nocheck>,
 python3-breathe <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 sphinx-common,
 libjs-mathjax <!nodoc>
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/xtensor-stack/xtensor-blas
Vcs-Browser: https://salsa.debian.org/science-team/xtensor-blas
Vcs-Git: https://salsa.debian.org/science-team/xtensor-blas.git
Rules-Requires-Root: no

Package: libxtensor-blas-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libxtensor-dev (>= 0.22.0~), libxtensor-dev (<< 0.23.0),
 libblis-dev | libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 ${misc:Depends}
Breaks: xtensor-blas-dev (<< 0.18.0-2~)
Replace: xtensor-blas-dev (<< 0.18.0-2~)
Description: an extension to xtensor offering bindings to BLAS and LAPACK
 xtensor-blas is an extension to the header-only xtensor library,
 offering bindings to BLAS and LAPACK libraries through cxxblas and
 cxxlapack from the FLENS project.
 .
 xtensor-blas currently provides non-broadcasting dot, norm (1- and
 2-norm for vectors), inverse, solve, eig, cross, det, slogdet,
 matrix_rank, inv, cholesky, qr, svd in the xt::linalg namespace
 (check the corresponding xlinalg.hpp header for the function
 signatures). The functions, and signatures, are trying to be 1-to-1
 equivalent to NumPy. Low-level functions to interface with BLAS or
 LAPACK with xtensor containers are also offered in the blas and
 lapack namespace.

Package: xtensor-blas-doc
Section: doc
Architecture: all
Depends: libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for xtensor-blas
 xtensor-blas is an extension to the header-only xtensor library,
 offering bindings to BLAS and LAPACK libraries through cxxblas and
 cxxlapack from the FLENS project.
 .
 xtensor-blas currently provides non-broadcasting dot, norm (1- and
 2-norm for vectors), inverse, solve, eig, cross, det, slogdet,
 matrix_rank, inv, cholesky, qr, svd in the xt::linalg namespace
 (check the corresponding xlinalg.hpp header for the function
 signatures). The functions, and signatures, are trying to be 1-to-1
 equivalent to NumPy. Low-level functions to interface with BLAS or
 LAPACK with xtensor containers are also offered in the blas and
 lapack namespace.
 .
 This package provides documentation for xtensor-blas.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS+=-DBUILD_TESTS=ON \
        -DGTEST_SRC_DIR="/usr/src/googletest"
else
BUILD_OPTIONS+=-DBUILD_TESTS=OFF
endif

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test -- xtest
endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/xtensor-stack/xtensor-blas/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## xtensor-blas 0.19.1

=== debian/changelog ===
xtensor-blas (0.19.1-6) unstable; urgency=medium

  * debian patch relax_lapack_cholevsky_test_tolerance_PR212.patch
    applies upstream PR#212 to relax the tolerances in
    xlapack.solveCholesky, needed for 32-bit arches to pass the test.
    Closes: Bug#996616.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Oct 2021 11:19:47 +0200

xtensor-blas (0.19.1-5) unstable; urgency=medium

  * debian patch fix_sphinx_api.patch updates sphinx API to fix doc
    build (upstream Issue #210).

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Oct 2021 23:58:34 +0200

xtensor-blas (0.19.1-4) experimental; urgency=medium

  * build docs only for arch-indep builds

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Sep 2021 19:35:47 +0200

xtensor-blas (0.19.1-3) experimental; urgency=medium

  * debian patch test_native.patch checks availability before adding
    -march=native to options when compiling tests. Closes: #986823.
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Sep 2021 11:48:21 +0200

xtensor-blas (0.19.1-2) experimental; urgency=medium

  * upload new package structure (libxtensor-blas-dev) for 0.19.1

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Jul 2021 17:04:11 +0200

xtensor-blas (0.19.1-1) experimental; urgency=medium

  * New upstream release.
    - Depends: xtensor-dev (>= 0.23.3~)

 -- Drew Parsons <dparsons@debian.org>  Sat, 10 Apr 2021 17:41:28 +0200

xtensor-blas (0.19.0-1) experimental; urgency=medium

  * New upstream release.
    - this xtensor-blas builds against xtensor 0.23.0
  * fix source package name in debian/watch
  * add debian patches
    - fix_dot_xtensor_0.23.1.patch fixes dot product in
      tests for xtensor 0.23.1, see upstream Issue#184.
    - find_generic_blas.patch instructs cmake to find generic
      libblas.so
  * set bounded Depends: xtensor-dev (>= 0.23.0~), xtensor-dev (<< 0.24)
  * mark libopenblas-dev as preferred over libblis-dev, since there is
    a specific option in CMakefileLists.txt to use OpenBLAS (used in
    xflens/cxxblas, not xtensor-blas itself)

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Mar 2021 18:41:11 +0100

xtensor-blas (0.18.0-3) unstable; urgency=medium

  * fix spelling in libxtensor-blas-dev Replaces: xtensor-blas-dev
    (not "Replace:"). Closes: #990847.

 -- Drew Parsons <dparsons@debian.org>  Sat, 10 Jul 2021 00:41:48 +0200

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(BUILD_OPTIONS)
 
-override_dh_auto_build:
+override_dh_auto_build-indep:
 	dh_auto_build
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) -C docs html

## xtensor-blas 0.19.2

=== CMakeLists.txt ===
#######################################################################
#  This is the makefile to create a library for LAPACK.
#  The files are organized as follows:
#       ALLAUX -- Auxiliary routines called from all precisions
#       ALLXAUX -- Auxiliary routines called from all precisions but
#                  only from routines using extra precision.
#       SCLAUX -- Auxiliary routines called from both REAL and COMPLEX
#       DZLAUX -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#       SLASRC -- Single precision real LAPACK routines
#       SXLASRC -- Single precision real LAPACK routines using extra
#                  precision.
#       CLASRC -- Single precision complex LAPACK routines
#       CXLASRC -- Single precision complex LAPACK routines using extra
#                  precision.
#       DLASRC -- Double precision real LAPACK routines
#       DXLASRC -- Double precision real LAPACK routines using extra
#                  precision.
#       ZLASRC -- Double precision complex LAPACK routines
#       ZXLASRC -- Double precision complex LAPACK routines using extra
#                  precision.
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       lapack.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#  ***Note***
#  The functions lsame, second, dsecnd, slamch, and dlamch may have
#  to be installed before compiling the library.  Refer to the
#  installation guide, LAPACK Working Note 41, for instructions.
#
#######################################################################

set(ALLAUX  ilaenv.f ieeeck.f lsamen.f  iparmq.f	
    ilaprec.f ilatrans.f ilauplo.f iladiag.f chla_transtype.f 
    ../INSTALL/ilaver.f ../INSTALL/lsame.f xerbla.f xerbla_array.f
    ../INSTALL/slamch.f)

set(ALLXAUX )

set(SCLAUX  
   sbdsdc.f 
   sbdsqr.f sdisna.f slabad.f slacpy.f sladiv.f slae2.f  slaebz.f 
   slaed0.f slaed1.f slaed2.f slaed3.f slaed4.f slaed5.f slaed6.f 
   slaed7.f slaed8.f slaed9.f slaeda.f slaev2.f slagtf.f 
   slagts.f slamrg.f slanst.f 
   slapy2.f slapy3.f slarnv.f 
   slarra.f slarrb.f slarrc.f slarrd.f slarre.f slarrf.f slarrj.f 
   slarrk.f slarrr.f slaneg.f 
   slartg.f slaruv.f slas2.f  slascl.f 
   slasd0.f slasd1.f slasd2.f slasd3.f slasd4.f slasd5.f slasd6.f 
   slasd7.f slasd8.f slasda.f slasdq.f slasdt.f 
   slaset.f slasq1.f slasq2.f slasq3.f slasq4.f slasq5.f slasq6.f 
   slasr.f  slasrt.f slassq.f slasv2.f spttrf.f sstebz.f sstedc.f 
   ssteqr.f ssterf.f slaisnan.f sisnan.f 
   slartgp.f slartgs.f 
   ${SECOND_SRC})

set(DZLAUX  
   dbdsdc.f 
   dbdsqr.f ddisna.f dlabad.f dlacpy.f dladiv.f dlae2.f  dlaebz.f 
   dlaed0.f dlaed1.f dlaed2.f dlaed3.f dlaed4.f dlaed5.f dlaed6.f 
   dlaed7.f dlaed8.f dlaed9.f dlaeda.f dlaev2.f dlagtf.f 
   dlagts.f dlamrg.f dlanst.f 
   dlapy2.f dlapy3.f dlarnv.f 
   dlarra.f dlarrb.f dlarrc.f dlarrd.f dlarre.f dlarrf.f dlarrj.f 
   dlarrk.f dlarrr.f dlaneg.f 
   dlartg.f dlaruv.f dlas2.f  dlascl.f 
   dlasd0.f dlasd1.f dlasd2.f dlasd3.f dlasd4.f dlasd5.f dlasd6.f 
   dlasd7.f dlasd8.f dlasda.f dlasdq.f dlasdt.f 
   dlaset.f dlasq1.f dlasq2.f dlasq3.f dlasq4.f dlasq5.f dlasq6.f 
   dlasr.f  dlasrt.f dlassq.f dlasv2.f dpttrf.f dstebz.f dstedc.f 
   dsteqr.f dsterf.f dlaisnan.f disnan.f 
   dlartgp.f dlartgs.f
   ../INSTALL/dlamch.f ${DSECOND_SRC})

set(SLASRC  
   sgbbrd.f sgbcon.f sgbequ.f sgbrfs.f sgbsv.f  
   sgbsvx.f sgbtf2.f sgbtrf.f sgbtrs.f sgebak.f sgebal.f sgebd2.f 
   sgebrd.f sgecon.f sgeequ.f sgees.f  sgeesx.f sgeev.f  sgeevx.f 
   sgegs.f  sgegv.f  sgehd2.f sgehrd.f sgelq2.f sgelqf.f 
   sgels.f  sgelsd.f sgelss.f sgelsx.f sgelsy.f sgeql2.f sgeqlf.f 
   sgeqp3.f sgeqpf.f sgeqr2.f sgeqr2p.f sgeqrf.f sgeqrfp.f sgerfs.f sgerq2.f sgerqf.f 
   sgesc2.f sgesdd.f sgesv.f  sgesvd.f sgesvx.f sgetc2.f sgetf2.f 
   sgetrf.f sgetri.f 
   sgetrs.f sggbak.f sggbal.f sgges.f  sggesx.f sggev.f  sggevx.f 
   sggglm.f sgghrd.f sgglse.f sggqrf.f 
   sggrqf.f sggsvd.f sggsvp.f sgtcon.f sgtrfs.f sgtsv.f  
   sgtsvx.f sgttrf.f sgttrs.f sgtts2.f shgeqz.f 
   shsein.f shseqr.f slabrd.f slacon.f slacn2.f 
   slaein.f slaexc.f slag2.f  slags2.f slagtm.f slagv2.f slahqr.f 
   slahrd.f slahr2.f slaic1.f slaln2.f slals0.f slalsa.f slalsd.f 
   slangb.f slange.f slangt.f slanhs.f slansb.f slansp.f 
   slansy.f slantb.f slantp.f slantr.f slanv2.f 
   slapll.f slapmt.f 
   slaqgb.f slaqge.f slaqp2.f slaqps.f slaqsb.f slaqsp.f slaqsy.f 
   slaqr0.f slaqr1.f slaqr2.f slaqr3.f slaqr4.f slaqr5.f 
   slaqtr.f slar1v.f slar2v.f ilaslr.f ilaslc.f 
   slarf.f  slarfb.f slarfg.f slarfgp.f slarft.f slarfx.f slargv.f 
   slarrv.f slartv.f 
   slarz.f  slarzb.f slarzt.f slaswp.f slasy2.f slasyf.f 
   slatbs.f slatdf.f slatps.f slatrd.f slatrs.f slatrz.f slatzm.f 
   slauu2.f slauum.f sopgtr.f sopmtr.f sorg2l.f sorg2r.f 
   sorgbr.f sorghr.f sorgl2.f sorglq.f sorgql.f sorgqr.f sorgr2.f 
   sorgrq.f sorgtr.f sorm2l.f sorm2r.f 
   sormbr.f sormhr.f sorml2.f sormlq.f sormql.f sormqr.f sormr2.f 
   sormr3.f sormrq.f sormrz.f sormtr.f spbcon.f spbequ.f spbrfs.f 
   spbstf.f spbsv.f  spbsvx.f 
   spbtf2.f spbtrf.f spbtrs.f spocon.f spoequ.f sporfs.f sposv.f  
   sposvx.f spotf2.f spotrf.f spotri.f spotrs.f spstrf.f spstf2.f 
   sppcon.f sppequ.f 
   spprfs.f sppsv.f  sppsvx.f spptrf.f spptri.f spptrs.f sptcon.f 
   spteqr.f sptrfs.f sptsv.f  sptsvx.f spttrs.f sptts2.f srscl.f  
   ssbev.f  ssbevd.f ssbevx.f ssbgst.f ssbgv.f  ssbgvd.f ssbgvx.f 
   ssbtrd.f sspcon.f sspev.f  sspevd.f sspevx.f sspgst.f 
   sspgv.f  sspgvd.f sspgvx.f ssprfs.f sspsv.f  sspsvx.f ssptrd.f 
   ssptrf.f ssptri.f ssptrs.f sstegr.f sstein.f sstev.f  sstevd.f sstevr.f 
   sstevx.f ssycon.f ssyev.f  ssyevd.f ssyevr.f ssyevx.f ssygs2.f 
   ssygst.f ssygv.f  ssygvd.f ssygvx.f ssyrfs.f ssysv.f  ssysvx.f 
   ssytd2.f ssytf2.f ssytrd.f ssytrf.f ssytri.f ssytri2.f ssytri2x.f
   ssyswapr.f ssytrs.f ssytrs2.f ssyconv.f stbcon.f 
   stbrfs.f stbtrs.f stgevc.f stgex2.f stgexc.f stgsen.f 
   stgsja.f stgsna.f stgsy2.f stgsyl.f stpcon.f stprfs.f stptri.f 
   stptrs.f 
   strcon.f strevc.f strexc.f strrfs.f strsen.f strsna.f strsyl.f 
   strti2.f strtri.f strtrs.f stzrqf.f stzrzf.f sstemr.f 
   slansf.f spftrf.f spftri.f spftrs.f ssfrk.f stfsm.f stftri.f stfttp.f 
   stfttr.f stpttf.f stpttr.f strttf.f strttp.f 
   sgejsv.f  sgesvj.f  sgsvj0.f  sgsvj1.f 
   sgeequb.f ssyequb.f spoequb.f sgbequb.f
   sbbcsd.f slapmr.f sorbdb.f sorcsd.f )

set(DSLASRC spotrs.f sgetrs.f spotrf.f sgetrf.f) 

set(SXLASRC  sgesvxx.f sgerfsx.f sla_gerfsx_extended.f sla_geamv.f		
   sla_gercond.f sla_rpvgrw.f ssysvxx.f ssyrfsx.f			
   sla_syrfsx_extended.f sla_syamv.f sla_syrcond.f sla_syrpvgrw.f	
   sposvxx.f sporfsx.f sla_porfsx_extended.f sla_porcond.f		
   sla_porpvgrw.f sgbsvxx.f sgbrfsx.f sla_gbrfsx_extended.f		
   sla_gbamv.f sla_gbrcond.f sla_gbrpvgrw.f sla_lin_berr.f slarscl2.f	
   slascl2.f sla_wwaddw.f)

set(CLASRC 
   cbdsqr.f cgbbrd.f cgbcon.f cgbequ.f cgbrfs.f cgbsv.f  cgbsvx.f 
   cgbtf2.f cgbtrf.f cgbtrs.f cgebak.f cgebal.f cgebd2.f cgebrd.f 
   cgecon.f cgeequ.f cgees.f  cgeesx.f cgeev.f  cgeevx.f 
   cgegs.f  cgegv.f  cgehd2.f cgehrd.f cgelq2.f cgelqf.f 
   cgels.f  cgelsd.f cgelss.f cgelsx.f cgelsy.f cgeql2.f cgeqlf.f cgeqp3.f 
   cgeqpf.f cgeqr2.f cgeqr2p.f cgeqrf.f cgeqrfp.f cgerfs.f cgerq2.f cgerqf.f 
   cgesc2.f cgesdd.f cgesv.f  cgesvd.f cgesvx.f cgetc2.f cgetf2.f cgetrf.f 
   cgetri.f cgetrs.f 
   cggbak.f cggbal.f cgges.f  cggesx.f cggev.f  cggevx.f cggglm.f 
   cgghrd.f cgglse.f cggqrf.f cggrqf.f 
   cggsvd.f cggsvp.f 
   cgtcon.f cgtrfs.f cgtsv.f  cgtsvx.f cgttrf.f cgttrs.f cgtts2.f chbev.f  
   chbevd.f chbevx.f chbgst.f chbgv.f  chbgvd.f chbgvx.f chbtrd.f 
   checon.f cheev.f  cheevd.f cheevr.f cheevx.f chegs2.f chegst.f 
   chegv.f  chegvd.f chegvx.f cherfs.f chesv.f  chesvx.f chetd2.f 
   chetf2.f chetrd.f 
   chetrf.f chetri.f chetri2.f  chetri2x.f cheswapr.f
   chetrs.f chetrs2.f chgeqz.f chpcon.f chpev.f  chpevd.f 
   chpevx.f chpgst.f chpgv.f  chpgvd.f chpgvx.f chprfs.f chpsv.f  
   chpsvx.f 
   chptrd.f chptrf.f chptri.f chptrs.f chsein.f chseqr.f clabrd.f 
   clacgv.f clacon.f clacn2.f clacp2.f clacpy.f clacrm.f clacrt.f cladiv.f 
   claed0.f claed7.f claed8.f 
   claein.f claesy.f claev2.f clags2.f clagtm.f 
   clahef.f clahqr.f 
   clahrd.f clahr2.f claic1.f clals0.f clalsa.f clalsd.f clangb.f clange.f clangt.f 
   clanhb.f clanhe.f 
   clanhp.f clanhs.f clanht.f clansb.f clansp.f clansy.f clantb.f 
   clantp.f clantr.f clapll.f clapmt.f clarcm.f claqgb.f claqge.f 
   claqhb.f claqhe.f claqhp.f claqp2.f claqps.f claqsb.f 
   claqr0.f claqr1.f claqr2.f claqr3.f claqr4.f claqr5.f 
   claqsp.f claqsy.f clar1v.f clar2v.f ilaclr.f ilaclc.f 
   clarf.f  clarfb.f clarfg.f clarfgp.f clarft.f 
   clarfx.f clargv.f clarnv.f clarrv.f clartg.f clartv.f 
   clarz.f  clarzb.f clarzt.f clascl.f claset.f clasr.f  classq.f 
   claswp.f clasyf.f clatbs.f clatdf.f clatps.f clatrd.f clatrs.f clatrz.f 
   clatzm.f clauu2.f clauum.f cpbcon.f cpbequ.f cpbrfs.f cpbstf.f cpbsv.f  
   cpbsvx.f cpbtf2.f cpbtrf.f cpbtrs.f cpocon.f cpoequ.f cporfs.f 
   cposv.f  cposvx.f cpotf2.f cpotrf.f cpotri.f cpotrs.f cpstrf.f cpstf2.f 
   cppcon.f cppequ.f cpprfs.f cppsv.f  cppsvx.f cpptrf.f cpptri.f cpptrs.f 
   cptcon.f cpteqr.f cptrfs.f cptsv.f  cptsvx.f cpttrf.f cpttrs.f cptts2.f 
   crot.f   cspcon.f cspmv.f  cspr.f   csprfs.f cspsv.f  
   cspsvx.f csptrf.f csptri.f csptrs.f csrscl.f cstedc.f 
   cstegr.f cstein.f csteqr.f csycon.f csymv.f  
   csyr.f   csyrfs.f csysv.f  csysvx.f csytf2.f csytrf.f csytri.f 
   csytri2.f csytri2x.f csyswapr.f
   csytrs.f csytrs2.f csyconv.f ctbcon.f ctbrfs.f ctbtrs.f ctgevc.f ctgex2.f 
   ctgexc.f ctgsen.f ctgsja.f ctgsna.f ctgsy2.f ctgsyl.f ctpcon.f 
   ctprfs.f ctptri.f 
   ctptrs.f ctrcon.f ctrevc.f ctrexc.f ctrrfs.f ctrsen.f ctrsna.f 
   ctrsyl.f ctrti2.f ctrtri.f ctrtrs.f ctzrqf.f ctzrzf.f cung2l.f cung2r.f 
   cungbr.f cunghr.f cungl2.f cunglq.f cungql.f cungqr.f cungr2.f 
   cungrq.f cungtr.f cunm2l.f cunm2r.f cunmbr.f cunmhr.f cunml2.f 
   cunmlq.f cunmql.f cunmqr.f cunmr2.f cunmr3.f cunmrq.f cunmrz.f 
   cunmtr.f cupgtr.f cupmtr.f icmax1.f scsum1.f cstemr.f 
   chfrk.f ctfttp.f clanhf.f cpftrf.f cpftri.f cpftrs.f ctfsm.f ctftri.f 
   ctfttr.f ctpttf.f ctpttr.f ctrttf.f ctrttp.f 
   cgeequb.f cgbequb.f csyequb.f cpoequb.f cheequb.f
   cbbcsd.f clapmr.f cunbdb.f cuncsd.f )

set(CXLASRC     cgesvxx.f cgerfsx.f cla_gerfsx_extended.f cla_geamv.f 
   cla_gercond_c.f cla_gercond_x.f cla_rpvgrw.f 
   csysvxx.f csyrfsx.f cla_syrfsx_extended.f cla_syamv.f 
   cla_syrcond_c.f cla_syrcond_x.f cla_syrpvgrw.f 
   cposvxx.f cporfsx.f cla_porfsx_extended.f 
   cla_porcond_c.f cla_porcond_x.f cla_porpvgrw.f 
   cgbsvxx.f cgbrfsx.f cla_gbrfsx_extended.f cla_gbamv.f 
   cla_gbrcond_c.f cla_gbrcond_x.f cla_gbrpvgrw.f 
   chesvxx.f cherfsx.f cla_herfsx_extended.f cla_heamv.f 
   cla_hercond_c.f cla_hercond_x.f cla_herpvgrw.f 
   cla_lin_berr.f clarscl2.f clascl2.f cla_wwaddw.f)

set(ZCLASRC cpotrs.f cgetrs.f cpotrf.f cgetrf.f) 

set(DLASRC 
   dgbbrd.f dgbcon.f dgbequ.f dgbrfs.f dgbsv.f  
   dgbsvx.f dgbtf2.f dgbtrf.f dgbtrs.f dgebak.f dgebal.f dgebd2.f 
   dgebrd.f dgecon.f dgeequ.f dgees.f  dgeesx.f dgeev.f  dgeevx.f 
   dgegs.f  dgegv.f  dgehd2.f dgehrd.f dgelq2.f dgelqf.f 
   dgels.f  dgelsd.f dgelss.f dgelsx.f dgelsy.f dgeql2.f dgeqlf.f 
   dgeqp3.f dgeqpf.f dgeqr2.f dgeqr2p.f dgeqrf.f dgeqrfp.f dgerfs.f dgerq2.f dgerqf.f

=== Makefile ===
FC = gfortran

FCFLAGS           += -g -fimplicit-none
FC_NOUNDERSCORING  = -fno-underscoring

SOURCE_FILES = $(filter-out ilaenv.f, $(wildcard *.f))

OBJECT_FILES_NOUNDERSCORING   =  $(filter-out xerbla_nu.o, $(patsubst %.f,%_nu.o,$(SOURCE_FILES)))

OBJECT_FILES_WITHUNDERSCORING =  $(patsubst %.f,%_wu.o,$(SOURCE_FILES))


REFLAPACK_NU = ../libreflapack_nu.a
REFLAPACK_WU = ../libreflapack_wu.a

all : $(REFLAPACK_NU) $(REFLAPACK_WU)

$(REFLAPACK_NU) : $(OBJECT_FILES_NOUNDERSCORING)
	ar crs $(REFLAPACK_NU) $(OBJECT_FILES_NOUNDERSCORING)
	ranlib $(REFLAPACK_NU)

$(REFLAPACK_WU) : $(OBJECT_FILES_WITHUNDERSCORING)
	ar crs $(REFLAPACK_WU) $(OBJECT_FILES_WITHUNDERSCORING)
	ranlib $(REFLAPACK_WU)

%_nu.o : %.f
	$(FC) $(FCFLAGS) $(FC_NOUNDERSCORING) -c -o $@ $<

%_wu.o : %.f
	$(FC) $(FCFLAGS) $(FC_WITHUNDERSCORING) -c -o $@ $<

clean :
	rm -f $(OBJECT_FILES_NOUNDERSCORING)
	rm -f $(OBJECT_FILES_WITHUNDERSCORING)
	rm -f $(REFLAPACK_NU)
	rm -f $(REFLAPACK_WU)

=== benchmark/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay and Wolf Vollprecht    #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xtensor-benchmark)

    find_package(xtensor REQUIRED CONFIG)
    set(XTENSOR_INCLUDE_DIR ${xtensor_INCLUDE_DIRS})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native -Wunused-parameter -Wextra -Wreorder")
    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else()
        message(FATAL_ERROR "Unsupported compiler -- xtensor requires C++14 support!")
    endif()

    # Enable link time optimization and set the default symbol
    # visibility to hidden (very important to obtain small binaries)
    if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
        # Default symbol visibility
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

        # Check for Link Time Optimization support
        # (GCC/Clang)
        # LTO had to be removed as google benchmark doesn't build with it
        # CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
        # if (HAS_LTO_FLAG)
        #     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
        # endif()

        # Intel equivalent to LTO is called IPO
        if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
            CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
            if (HAS_IPO_FLAG)
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ipo")
            endif()
        endif()
    endif()
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP /bigobj")
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    foreach(flag_var
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        string(REPLACE "/MD" "-MT" ${flag_var} "${${flag_var}}")
    endforeach()
endif()


if(DOWNLOAD_GBENCHMARK OR GBENCHMARK_SRC_DIR)
    if(DOWNLOAD_GBENCHMARK)
        # Download and unpack googlebenchmark at configure time
        configure_file(downloadGBenchmark.cmake.in googlebenchmark-download/CMakeLists.txt)
    else()
        # Copy local source of googlebenchmark at configure time
        configure_file(copyGBenchmark.cmake.in googlebenchmark-download/CMakeLists.txt)
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-download )
    if(result)
        message(FATAL_ERROR "CMake step for googlebenchmark failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-download )
    if(result)
        message(FATAL_ERROR "Build step for googlebenchmark failed: ${result}")
    endif()

    # Add googlebenchmark directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-src
                     ${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-build)

    set(GBENCHMARK_INCLUDE_DIRS "${googlebenchmark_SOURCE_DIR}/include")
    set(GBENCHMARK_LIBRARIES benchmark)
else()
    find_package(benchmark REQUIRED)
endif()


message(STATUS "BLAS VENDOR:    " ${BLA_VENDOR})
message(STATUS "BLAS LIBRARIES: " ${BLAS_LIBRARIES})

if (HAVE_CBLAS)
    if (WIN32)
        find_package(OpenBLAS REQUIRED)
        set(BLAS_LIBRARIES ${CMAKE_INSTALL_PREFIX}${OpenBLAS_LIBRARIES})
    else()
        find_package(BLAS REQUIRED)
        find_package(LAPACK REQUIRED)
    endif()
    add_definitions(-DHAVE_CBLAS=1 -DWITH_OPENBLAS=1)
endif()

include_directories(${XTENSOR_INCLUDE_DIR} ${GBENCHMARK_INCLUDE_DIRS})

set(XTENSOR_BENCHMARK
    main.cpp
    benchmark_blas.hpp
)

set(XTENSOR_BENCHMARK_TARGET benchmark_xtensor)
add_executable(${XTENSOR_BENCHMARK_TARGET} EXCLUDE_FROM_ALL ${XTENSOR_BENCHMARK} ${XTENSOR_HEADERS})
target_link_libraries(${XTENSOR_BENCHMARK_TARGET} ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES} ${GBENCHMARK_LIBRARIES})

add_custom_target(xbenchmark
    COMMAND benchmark_xtensor
    DEPENDS ${XTENSOR_BENCHMARK_TARGET})

add_custom_target(xpowerbench
    COMMAND echo "sudo needed to set cpu power governor to performance"
    COMMAND sudo cpupower frequency-set --governor performance
    COMMAND benchmark_xtensor
    COMMAND sudo cpupower frequency-set --governor powersave
    DEPENDS ${XTENSOR_BENCHMARK_TARGET})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -145,6 +145,7 @@
     test_dot.cpp
     test_dot_extended.cpp
     test_qr.cpp
+    test_float_norm.cpp
 )
 
 add_executable(test_xtensor_blas ${XTENSOR_BLAS_TESTS} ${XTENSOR_BLAS_HEADERS} ${XTENSOR_HEADERS})

=== include/xflens/cxxblas/CMakeLists.txt ===
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/flens
  FILES_MATCHING
  PATTERN "*.h"
  PATTERN "*.tcc"
  PATTERN "*.cxx"
  PATTERN "netlib" EXCLUDE
)

=== include/xflens/cxxlapack/netlib/Makefile ===
all : lapack/
	$(MAKE) -C lapack

lapack/ :
	tar xfz lapack.tgz

clean : lapack/
	$(MAKE) -C lapack clean

distclean : clean
	$(RM) -rf lapack/

=== debian/changelog ===
xtensor-blas (0.19.2-1) unstable; urgency=medium

  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Thu, 18 Nov 2021 18:53:12 +0100

xtensor-blas (0.19.1-7) unstable; urgency=medium

  * switch off -march=native on mipsel, where tests are flakey
    (success depends on specific CPU model).
    cmake config flag -Darch_native_supported=OFF
  * override dh_auto_clean to remove build-generated headers
    (xblas_config_cling.hpp)

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Oct 2021 15:48:44 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Maintainer: Drew Parsons <dparsons@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake (>= 3.1),
- libxtensor-dev (>= 0.22.0~), libxtensor-dev (<< 0.23.0),
- libblas-dev | libblis-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
+ libxtensor-dev (>= 0.23.3~), libxtensor-dev (<< 0.24),
+ libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
  liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
  googletest <!nocheck>,
  python3-breathe <!nodoc>,
@@ -12,7 +12,7 @@
  python3-sphinx-rtd-theme <!nodoc>,
  sphinx-common,
  libjs-mathjax <!nodoc>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/xtensor-stack/xtensor-blas
 Vcs-Browser: https://salsa.debian.org/science-team/xtensor-blas
@@ -23,12 +23,12 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libxtensor-dev (>= 0.22.0~), libxtensor-dev (<< 0.23.0),
- libblis-dev | libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
+Depends: libxtensor-dev (>= 0.23.3~), libxtensor-dev (<< 0.24),
+ libopenblas-dev | libblis-dev | libatlas-base-dev | libblas-dev | libblas.so,
  libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
  ${misc:Depends}
 Breaks: xtensor-blas-dev (<< 0.18.0-2~)
-Replace: xtensor-blas-dev (<< 0.18.0-2~)
+Replaces: xtensor-blas-dev (<< 0.18.0-2~)
 Description: an extension to xtensor offering bindings to BLAS and LAPACK
  xtensor-blas is an extension to the header-only xtensor library,
  offering bindings to BLAS and LAPACK libraries through cxxblas and

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 # See debhelper(7) (uncomment to enable)
 # output every command that modifies files on the build system.
 #export DH_VERBOSE = 1
+
+include /usr/share/dpkg/default.mk
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 BUILD_OPTIONS+=-DBUILD_TESTS=ON \
@@ -10,8 +12,20 @@
 BUILD_OPTIONS+=-DBUILD_TESTS=OFF
 endif
 
+# -march=native on mipsel is unreliable,
+# success depends on the machine (specific CPU model)
+# Best to just switch off -march=native
+# (allow it on other arches in order to test the typical user experience)
+ifneq (,$(findstring $(DEB_HOST_ARCH),mipsel))
+  BUILD_OPTIONS += -Darch_native_supported=OFF
+endif
+
 %:
 	dh $@ --with sphinxdoc
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f include/xtensor-blas/xblas_config_cling.hpp
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(BUILD_OPTIONS)

=== debian/tests/control ===
Test-Command: set -e
 ; cp -r ./test/* "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with gcc:"
 ; mkdir build && cd build
 ; CC=gcc CXX=g++ cmake .. -DGTEST_SRC_DIR="/usr/src/googletest"
 ; CTEST_OUTPUT_ON_FAILURE=1 make -j $(nproc) xtest
Depends: cmake,
 g++,
 googletest,
 libxtensor-dev,
 libxtensor-blas-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp -r ./test/* "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with clang:"
 ; mkdir build && cd build
 ; CC=clang CXX=clang++ cmake .. -DGTEST_SRC_DIR="/usr/src/googletest"
 ; CTEST_OUTPUT_ON_FAILURE=1 make -j $(nproc) xtest
Depends: clang,
 cmake,
 googletest,
 libxtensor-dev,
 libxtensor-blas-dev
Restrictions: allow-stderr
